<!doctype html>
<!--
    Copyright (c) 2010, 2025 Contributors to the Eclipse Foundation

    See the NOTICE file(s) distributed with this work for additional
    information regarding copyright ownership.

    This program and the accompanying materials are made available under the terms
    of the MIT License which is available at https://opensource.org/licenses/MIT

    SPDX-License-Identifier: MIT
-->
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Module 4.2 | SBE Course</title>
        <link rel="icon" type="image/png" href="../sbe-course-favicon.png"/>

        <!-- Bootstrap. -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.0/font/bootstrap-icons.css" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>

        <!-- Website styling. -->
        <link rel="stylesheet" href="../../assets/eclipse-escet.css">
        <link rel="stylesheet" href="../../assets/eclipse-escet-sbe-course.css">

        <!-- Version selector. -->
        <script src="../../assets/eclipse-escet.js"></script>

        <!-- Code block syntax highlighting. -->
        <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css">
        <script src="../../assets/highlight.min.js"></script>
        <script src="../../assets/languages/cif.min.js"></script>
        <script src="../../assets/languages/tooldef.min.js"></script>

        <!-- Quiz. -->
        <link rel="stylesheet" href="../assets/quiz.css">
        <script src="../assets/quiz.js"></script>

        <!-- SBE course. -->
        <link rel="stylesheet" href="../assets/course.css">
        <script src="../assets/course.js"></script>
    </head>

    <body class="escet-dark">

        <!-- Top navigation bar -->
        <nav class="navbar navbar-expand-lg navbar-dark escet-bg">
            <div class="container-fluid">
                <a class="navbar-brand d-lg-none">SBE Course</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-0 mb-lg-0">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle escet-brand px-0" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">Eclipse ESCET™ / SBE Course</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <li><a class="dropdown-item" href="../.."><img src="../../eclipse-escet-favicon.png" class="pe-2"> Eclipse ESCET / Project</a></li>
                                <li><a class="dropdown-item" href=".."><img src="../sbe-course-favicon.png" class="pe-2"> Eclipse ESCET / SBE Course</a></li>
                                <li><a class="dropdown-item" href="../../cif"><img src="../../cif/cif-favicon.png" class="pe-2"> Eclipse ESCET / CIF</a></li>
                                <li><a class="dropdown-item" href="../../chi"><img src="../../chi/chi-favicon.png" class="pe-2"> Eclipse ESCET / Chi</a></li>
                                <li><a class="dropdown-item" href="../../tooldef"><img src="../../tooldef/tooldef-favicon.png" class="pe-2"> Eclipse ESCET / ToolDef</a></li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="../" aria-expanded="false">Home</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown1" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 1</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown1">
                                <li><a class="dropdown-item" href="../module1">Module 1: Supervisory control of discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/supervisory-control.html">Module 1.1: Supervisory control</a></li>
                                <li><a class="dropdown-item" href="../module1/discrete-event-systems.html">Module 1.2: Discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/modeling-discrete-event-systems.html">Module 1.3: Modeling discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/get-started-with-cif.html">Module 1.4: Get started with CIF</a></li>
                                <li><a class="dropdown-item" href="../module1/exercises.html">Module 1.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module1/introduction-to-the-water-lock-case.html">Module 1.6: Introduction to the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown2" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 2</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown2">
                                <li><a class="dropdown-item" href="../module2">Module 2: Working with automata</a></li>
                                <li><a class="dropdown-item" href="../module2/reachability-deadlock-blocking-livelock.html">Module 2.1: Reachability, deadlock, blocking and livelock</a></li>
                                <li><a class="dropdown-item" href="../module2/non-deterministic-automata.html">Module 2.2: Non-deterministic automata</a></li>
                                <li><a class="dropdown-item" href="../module2/synchronizing-automata.html">Module 2.3: Synchronizing automata</a></li>
                                <li><a class="dropdown-item" href="../module2/shared-variables.html">Module 2.4: Shared variables</a></li>
                                <li><a class="dropdown-item" href="../module2/computing-state-spaces.html">Module 2.5: Computing state spaces</a></li>
                                <li><a class="dropdown-item" href="../module2/cif-tools-view-analyze-models.html">Module 2.6: CIF tools to view and analyze models</a></li>
                                <li><a class="dropdown-item" href="../module2/constants-and-algebraic-variables.html">Module 2.7: Constants and algebraic variables</a></li>
                                <li><a class="dropdown-item" href="../module2/exercises.html">Module 2.8: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module2/more-detailed-models-water-lock-case.html">Module 2.9: More detailed models for the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown3" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 3</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown3">
                                <li><a class="dropdown-item" href="../module3">Module 3: Supervisory control and plant models</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-control-loop.html">Module 3.1: Supervisory control loop</a></li>
                                <li><a class="dropdown-item" href="../module3/synthesis-guarantees.html">Module 3.2: Synthesis guarantees</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-controller-synthesis.html">Module 3.3: Supervisory controller synthesis</a></li>
                                <li><a class="dropdown-item" href="../module3/modeling-larger-systems.html">Module 3.4: Modeling larger systems</a></li>
                                <li><a class="dropdown-item" href="../module3/exercises.html">Module 3.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module3/water-lock-case-plant-models.html">Module 3.6: Water lock case plant models</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle active" aria-current="page" href="#" id="navbarDropdown4" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 4</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown4">
                                <li><a class="dropdown-item" href="./">Module 4: Modeling requirements and supervisor synthesis</a></li>
                                <li><a class="dropdown-item" href="user-specified-requirements.html">Module 4.1: User-specified requirements</a></li>
                                <li><a class="dropdown-item active" aria-current="page" href="requirement-automata-and-invariants.html">Module 4.2: Requirements automata and invariants</a></li>
                                <li><a class="dropdown-item" href="synthesis-with-requirements.html">Module 4.3: Synthesis with requirements</a></li>
                                <li><a class="dropdown-item" href="modeling-for-synthesis.html">Module 4.4: Modeling for synthesis</a></li>
                                <li><a class="dropdown-item" href="performing-synthesis-with-cif.html">Module 4.5: Performing synthesis with CIF</a></li>
                                <li><a class="dropdown-item" href="introduction-to-svg-visualization.html">Module 4.6: Introduction to SVG visualization</a></li>
                                <li><a class="dropdown-item" href="exercises.html">Module 4.7: Exercises</a></li>
                                <li><a class="dropdown-item" href="water-lock-case-requirements-and-supervisor.html">Module 4.8: Water lock case requirements and supervisor</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown5" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 5</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown5">
                                <li><a class="dropdown-item" href="../module5">Module 5: Hybrid simulation models</a></li>
                                <li><a class="dropdown-item" href="../module5/timed-and-hybrid-models.html">Module 5.1: Timed and hybrid models</a></li>
                                <li><a class="dropdown-item" href="../module5/variable-time.html">Module 5.2: Variable 'time'</a></li>
                                <li><a class="dropdown-item" href="../module5/continuous-variables.html">Module 5.3: Continuous variables</a></li>
                                <li><a class="dropdown-item" href="../module5/urgency.html">Module 5.4: Urgency</a></li>
                                <li><a class="dropdown-item" href="../module5/tau-event.html">Module 5.5: The 'tau' event</a></li>
                                <li><a class="dropdown-item" href="../module5/exercises.html">Module 5.6: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module5/water-lock-case-hybrid-model.html">Module 5.7: Water lock case hybrid model</a></li>
                                <li><a class="dropdown-item" href="../module5/course-conclusion.html">Module 5.8: Course conclusion</a></li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <!-- Intro -->
        <div id="intro" class="position-relative p-3 text-center escet-bg escet-bg-opacity-125">
            <div class="clearfix mb-4 mb-md-0">
                <span class="float-end">
                    Version:
                    <div class="dropdown d-inline-block">
                        <a class="dropdown-toggle" href="#" role="button" id="versionDropdown" data-bs-toggle="dropdown" aria-expanded="false">v7.0-M1</a>
                        <ul id="versions-dropdown" class="dropdown-menu dropdown-menu-end" aria-labelledby="versionDropdown" data-this-version="/v7.0-M1">
                            <li><h6 id="versions-previews" class="dropdown-header">Previews</h6></li>
                            <li><h6 id="versions-latest-releases" class="dropdown-header">Latest releases</h6></li>
                            <li><h6 class="dropdown-header">Other</h6></li>
                            <li><a class="dropdown-item" href="../../versions.html">All versions...</a></li>
                        </ul>
                    </div>
                    <a class="text-nowrap ms-3" href="../../release-notes.html">[release notes]</a>
                </span>
            </div>
        </div>

        <!-- Content -->
        <div class="px-4 pt-5">
            <div class="row justify-content-center">
                <div class="col-12 col-md-10 col-xl-8 col-xxl-6" id="content">

                    <h1>Module 4.2: Requirement automata and invariants</h1>
                    <p>
                        As already mentioned in the previous sub-module, requirements can be specified in different ways.
                        The two main forms are requirement automata and requirement invariants.
                        And requirement invariants also come in two different forms: state requirement invariants and state/event exclusion requirements.
                        These three forms of requirements all restrict the allowed behavior of the system, either by indicating what must never be allowed to happen, or by specifying that only certain things are allowed to happen, meaning that all other things are disallowed.
                        Restrictions are thus specified in a positive or negative way, but they are always restrictions nonetheless.
                    </p>

                    <h2 id="example">Example</h2>
                    <p>
                        To explain the difference between the different forms of requirements, we will consider an example of bridge deck and traffic light, similar to <a href="../module1/modeling-discrete-event-systems.html">the one from the first module</a>.
                        The bridge deck can be closed, partially open or fully open.
                        The traffic light can be red or green.
                        The plants of this system can be modeled as follows:
                    </p>
                    <img src="images/bridge-deck-and-traffic-light-plants.png">
                    <p>
                        Together, these two components define the following state space for the uncontrolled system:
                    </p>
                    <img src="images/bridge-deck-and-traffic-light-uncontrolled.png">
                    <p>
                        For safety reasons, we do not want the bridge deck to be partially or fully open while the light is green, as then cars could drive off the bridge into the water.
                        This phrases the safety requirement negatively, by describing what is not allowed.
                        This same requirement can also be phrased positively, in terms of what is allowed: the bridge deck may only be partially or fully open while the light is red.
                        Alternatively, we could say that the bridge must be closed when the light is green.
                    </p>
                    <p>
                        Next, we will model this requirement in each of the three different forms.
                    </p>

                    <h2 id="requirement-automata">Requirement automata</h2>
                    <p>
                        Requirements can be specified as <em>requirement automata</em>, similar to how plant automata can be specified.
                        In fact, there is no difference in what can be modeled for plant and requirement automata, except that they are either indicated as being a plant or a requirement.
                        Requirement automata thus have location and edges, and they can also have variables, guards, and updates.
                        And it is possible to make requirement automaton definitions and instantiate them multiple times.
                    </p>
                    <p>
                        The purposes of plant and requirement automata are different.
                        A plant automaton specifies what the system can do, while a requirement automaton specifies what it is allowed to do.
                        As with all automata, they synchronize on shared events.
                        This way, a requirement automaton may restrict the behavior of the system.
                        That is, if a certain event in the alphabet of a requirement automaton is not possible in one of the locations of the requirement automaton, while it is allowed in the plant, then the requirement automaton imposes a restriction.
                    </p>
                    <p>
                        One way to make a requirement automaton is to take one or more plant automata, compute their state space, and remove some behavior from it.
                        If we do that for the bridge deck and traffic light example above, we could make the following requirement automaton:
                    </p>
                    <img src="images/bridge-deck-and-traffic-light-requirement.png">
                    <p>
                        This is a copy of the combined state space of the bridge deck and traffic light plant components, with some behavior removed from it.
                        The two states that are unsafe have been removed, as have all transitions to these states.
                        What remains is the allowed behavior, described as a requirement automaton.
                        Certain behavior is restricted.
                        For instance, when the bridge deck is open and the traffic light is red, the traffic light is not allowed to be turned to green.
                        Putting this requirement together with the plant, it restricts the behavior of the plant, ensuring that the controlled system can never get to the unsafe states.
                    </p>

                    <h2 id="requirement-invariants">State requirement invariants</h2>
                    <p>
                        Requirements can be also be specified by <em>state requirement invariants</em>, which are also called <em>state invariant requirements</em> or <em>requirement state invariants</em>.
                        This form of requirements allows you to specify a condition, in the form of a predicate, that must hold in all states of the controlled system.
                        Any state that does not adhere to this condition is deemed a bad state, and synthesis will ensure it can never be reached.
                    </p>
                    <p>
                        For instance, for the bridge deck and traffic light example, we could specify a state requirement invariants, with the following condition:
                    </p>
                    <ol>
                        <li><code>not ((BridgeDeck.PartiallyOpen or BridgeDeck.Open) and TrafficLight.Green)</code></li>
                    </ol>
                    <p>
                        This specifies that it must not be the case, that the bridge deck is partially open or fully open and at the same the traffic light is green.
                        This is phrased negatively.
                        We could also phrase it positively:
                    </p>
                    <ol start="2">
                        <li><code>(BridgeDeck.Closed and TrafficLight.Green) or TrafficLight.Red</code></li>
                    </ol>
                    <p>
                        This specifies that it must always be the case that, either the bridge deck is closed and the traffic light is green, or the traffic light is red.
                        It does not indicate what the bridge deck must be when the traffic light is red, and thus it may have any state that is possible in the plant.
                        That is, if the traffic light is red, the bridge deck may be closed, partially open or fully open.
                    </p>
                    <p>
                        The two requirements have the same effect, but are phrased differently.
                        In this case, the negative phrasing more directly indicates the bad states, while the positive phrasing prevents the use of the negation (<code>not</code>).
                        The choice of how to write a requirement invariant depends on the modeler's preference.
                        But, in general, you should opt for what is the most direct, simple and readable.
                    </p>

                    <h2>State/event exclusion requirement invariants</h2>
                    <p>
                        The third and final form of requirements is <em>state/event exclusion requirement invariants</em>, which are also called <em>state/event exclusion invariant requirements</em> or <em>requirement state/event exclusion invariants</em>.
                        This form of requirements allow you to specify a condition, in the form of a predicate, that must hold for an event to be enabled or disabled in certain states.
                        If the condition is for disabling an event, synthesis will ensure the event is disabled in all states where the predicate holds.
                        If the condition is for enabling an event, synthesis will ensure the event is disabled in all states where the predicate doesn't hold, such that it is only enabled in states where the predicate holds.
                    </p>
                    <p>
                        For instance, for the bridge deck and traffic light example, we could specify the following state/event exclusion requirement invariants to disable certain events in certain states:
                    </p>
                    <ol start="3">
                        <li><code>BridgeDeck.Closed and TrafficLight.Green <strong>disables</strong> partially_opened</code></li>
                        <li><code>BridgeDeck.PartiallyOpen or BridgeDeck.Open <strong>disables</strong> to_green</code></li>
                    </ol>
                    <p>
                        The first requirement disables the <code>partially_opened</code> event in the state where the bridge deck is closed and the traffic light is green.
                        This prevents transitioning from the <code>Closed/Green</code> state to the <code>PartiallyOpen/Green</code> state.
                        Similarly, the second requirement disables the <code>to_green</code> event in states where the bridge deck is partially open or fully open.
                        It prevents transitioning from the <code>PartiallyOpen/Red</code> state to the <code>PartiallyOpen/Green</code> state, and from the <code>Open/Red</code> state to the <code>Open/Green</code> state.
                    </p>
                    <p>
                        The requirements above restrict only the direct transitions to bad states.
                        Synthesis will prevent reaching those bad states, and thus any transitions from the bad states are also not possible.
                        We may exploit this in phrasing requirements, which can help to make requirements simpler.
                        For instance, the above two requirements could also be written as:
                    </p>
                    <ol start="5">
                        <li><code>TrafficLight.Green <strong>disables</strong> partially_opened</code></li>
                        <li><code>BridgeDeck.PartiallyOpen or BridgeDeck.Open <strong>disables</strong> to_green</code></li>
                    </ol>
                    <p>
                        The first requirement is changed, by dropping the <code>BridgeDeck.Closed</code> part of the condition.
                        It is fine to also disable the <code>partially_opened</code> event in the <code>Open/Green</code> state, as that is a bad state.
                    </p>
                    <p>
                        Besides that, predicates can often be written in different way by making use of the fact that only a limited number of locations are present in automata.
                        The bridge deck being partially open or fully open is therefore the same as it not being closed.
                        We may thus also write the above two requirements as:
                    </p>
                    <ol start="7">
                        <li><code>not TrafficLight.Red <strong>disables</strong> partially_opened</code></li>
                        <li><code>not BridgeDeck.Closed <strong>disables</strong> to_green</code></li>
                    </ol>
                    <p>
                        Which of these forms is better, depends on the modeler's preference, and what is simpler and more readable.
                    </p>
                    <p>
                        Besides these different ways of writing the requirements in a negative form, indicating when the events are disabled, they can also be specified positively, indicating when the events are enabled/allowed:
                    </p>
                    <ol start="9">
                        <li><code>partially_opened <strong>needs</strong> TrafficLight.Red</code></li>
                        <li><code>to_green <strong>needs</strong> BridgeDeck.Closed</code></li>
                    </ol>
                    <p>
                        This indicates that for the bridge deck to be partially opened, the traffic light needs to be red.
                        If it is green, this event is thus not allowed.
                        Similarly, for the traffic light to be turned to green, the bridge deck needs to be closed.
                        If the bridge deck is partially or fully open, the light may thus not be turned to green.
                    </p>
                    <p>
                        As with state requirement invariants, which form to use, positive or negative, depends on preference and readability.
                        A positively stated state/event exclusion requirement invariants <code>e <strong>needs</strong> p</code> (like 9 and 10 above) can always be phrased negatively as <code>not p <strong>disables</strong> e</code> (like 7 and 8 above), and vice versa.
                    </p>

                    <h2>Choosing the best requirement form</h2>
                    <p>
                        For the example above, the requirement automaton is arguably the least suited form.
                        It requires modeling a full automaton, with four locations and even more edges.
                        Also, it indicates what is allowed, which means you mentally have to check what is disabled, and thus what is expressed as a requirement.
                    </p>
                    <p>
                        The invariants are more succinct.
                        The different forms of requirement invariants (1, 2, 3+4, 5+6, 7+8, or 9+10) have their pros and cons as well.
                        Variants 9+10 are the shortest, but require a mental step to invert the conditions to see what is disabled.
                        Variants 7+8 use double negations (<code>not</code> and <code><strong>disables</strong></code>) and are thus best avoided.
                        Variants 5+6 directly indicate what is disabled, and are not much longer than 9+10, and are thus a good choice.
                        Variants 3+4 are needlessly longer than 5+6 and are thus best avoid as well.
                    </p>
                    <p>
                        Variant 2 also requires mentally inverting the condition to see what states are being forbidden.
                        Variant 1 is in that sense the better option, even though it uses a negation.
                    </p>
                    <p>
                        In the end, it is up to you to decide which form you think is the most intuitive.
                        But, variant 1 and variants 5+6 could be seen as the best options for this particular example.
                    </p>

                    <h2 id="requirement-order">Requirement automata to specify order</h2>
                    <p>
                        In the previous example of a bridge deck and traffic light, the requirement automaton was not the best option.
                        Let us now consider another example, of a railway crossing, where a requirement automaton could be a good option.
                        A red light can be on, signaling that a train is coming, and is off otherwise.
                        A barrier is closed if a train approaches, such that road traffic can't cross the tracks.
                        Once the train has passed, the barrier opens again.
                        The plant of this railway crossing can be modeled as follows:
                    </p>
                    <img src="images/railway-plant.png">
                    <p>
                        The light is initially <em>Off</em>, but can be turned on.
                        If it is <em>On</em>, it can be turned off again.
                        And so on.
                        The barrier is initially <em>Open</em>.
                        It can be closed, opened, closed, opened, and so on.
                    </p>
                    <p>
                        Together, these two components have the following state space:
                    </p>
                    <img src="images/railway-plant-statespace.png">
                    <p>
                        To prevents potential collisions of road traffic with trains, some of this behavior is to be prevented.
                        That is, for safety reasons, we want the light to be turned on, before the barrier is opened.
                        Then, only once the light is turned off again, should the barrier be opened again.
                    </p>
                    <p>
                        We could model this using the following requirement:
                    </p>
                    <img src="images/railway-requirement.png">
                    <p>
                        This is a simple requirement, that indicates the order in which the four controllable events are allowed to happen.
                        State requirement invariants are not applicable here, as we do not wish to restrict the states of the plant, but only the transitions.
                        State/event exclusion requirement invariants are an alternative, but it would require four of them, one per event.
                        The requirement automaton could be seen as the best option here, as it most intuitively and directly specifies the allowed order of events.
                    </p>
                    <p>
                        Do note, that this particular example may be too restrictive in practice.
                        It for instance does not allow turning off the light if it was turned on by mistake, at least not without first closing the barrier.
                    </p>

                    <h2>Quiz</h2>
                    <div class="quiz">
                        [
                            {
                                type: 'multiple-choice',
                                question: "Which of the following should be requirements, rather than being part of the plant?",
                                answers: [
                                    "An automaton that describes the behavior of a button.",
                                    "An automaton that describes that a motor should not be unnecessarily turned on and off.",
                                    "An automaton that describes how a product must be checked after it has been processed.",
                                    "An automaton that describes how products can enter the system.",
                                    "An automaton that describes that a gate must be open for a car to go through it.",
                                    "An automaton that describes the behavior of a motor.",
                                ],
                                correctAnswer: '2, 3, 5'
                            },
                            {
                                type: 'single-choice',
                                question: "Is the alphabet of a requirement automaton always the same as the plant alphabet?",
                                answers: [
                                    "Yes.",
                                    "No.",
                                ],
                                correctAnswer: '2'
                            },
                            {
                                type: 'multiple-choice',
                                question: `
                                    Consider a <code>Button</code> that can be <code>Pushed</code> or <code>Released</code> and a <code>Lamp</code> that can be <code>On</code> or <code>Off</code>.
                                    The lamp can be turned on or off by the events <code>turn_on</code> and <code>turn_off</code>, respectively.
                                    Which of the following requirements impose the same restriction as requirement <code>Button.Pushed <strong>disables</strong> turn_off</code>?
                                `,
                                answers: [
                                    "<code>Button.Pushed <strong>disables</strong> turn_on</code>",
                                    "<code>Button.Released <strong>disables</strong> turn_off</code>",
                                    "<code>Button.Released <strong>disables</strong> turn_on</code>",
                                    "<code>not Button.Pushed <strong>disables</strong> turn_off</code>",
                                    "<code>not Button.Pushed <strong>disables</strong> turn_on</code>",
                                    "<code>not Button.Released <strong>disables</strong> turn_off</code>",
                                    "<code>not Button.Released <strong>disables</strong> turn_on</code>",
                                    "<code>turn_off <strong>needs</strong> Button.Pushed</code>",
                                    "<code>turn_on <strong>needs</strong> Button.Pushed</code>",
                                    "<code>turn_off <strong>needs</strong> Button.Released</code>",
                                    "<code>turn_on <strong>needs</strong> Button.Released</code>",
                                    "<code>turn_off <strong>needs</strong> not Button.Pushed</code>",
                                    "<code>turn_on <strong>needs</strong> not Button.Pushed</code>",
                                    "<code>turn_off <strong>needs</strong> not Button.Released</code>",
                                    "<code>turn_on <strong>needs</strong> not Button.Released</code>",
                                ],
                                correctAnswer: '6, 10, 12'
                            }
                        ]
                    </div>

                    <div class="course-navigation-footer">
                        <div class="course-navigation-prev"><a href="user-specified-requirements.html">Go back to Module 4.1</a></div>
                        <div class="course-navigation-separator">|</div>
                        <div class="course-navigation-next"><a href="synthesis-with-requirements.html">Proceed to Module 4.3</a></div>
                    </div>

                </div>
            </div>
        </div>

        <!-- Footer -->
        <div class="container" id="footer">
            <footer class="pt-3 mt-4">
                <ul class="nav justify-content-center border-top pb-1 mb-1">
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org">Eclipse Home</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/privacy.php">Eclipse Privacy Policy</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/termsofuse.php">Eclipse Terms of Use</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/copyright.php">Eclipse Copyright Agent</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal">Eclipse Legal</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.dev/escet/legal.html">Eclipse ESCET Legal</a></li>
                </ul>
                <p class="text-center text-muted">Copyright © 2010, 2025 Contributors to the Eclipse Foundation</p>
            </footer>
        </div>

    </body>
</html>
